Есть ли способ установить Chrome / Chromium в изолированную среду от Firefox? - proUbuntu
0 голосов
/ 24 октября

Я убежден, что когда Firefox и Chrome / Chromium устанавливаются вместе в одной системе Ubuntu, то Chrome / Chromium делает что-то, что делает Firefox медленнее и менее надежным.

Всякий раз, когда я устанавливаю Chrome / Chromium в систему Ubuntu, система всегда очень медленно работает примерно через месяц. У меня много систем Ubuntu, и это происходит все время , по крайней мере, в течение последних двух лет, буквально.

Когда я устанавливаю Firefox и Chrome / Chromium, самые раздражающие вещибывает. Это работает в течение нескольких дней, затем Firefox смехотворно медленно запускается. Одной из моих машин потребовалось почти 10 минут, чтобы загрузить Firefox, в то время как с Chrome / Chromium это было мгновенно.

Я действительно предпочитаю Firefox, потому что к нему не добавлена ​​ни одна из этих отрывочных BS. Но мне нужен Chrome / Chromium, чтобы иметь возможность отлаживать веб-просмотр внутри моего приложения для Android. Итак, есть ли способ установить Chrome / Chromium в изолированную среду, в которой все еще можно использовать USB, не нарушая Firefox?

(Существуют ли альтернативные программы для браузеров Google для отладки веб-просмотров Android, которые незаставить меня переустанавливать Ubuntu 16.04 через месяц после их установки?)

1 Ответ

0 голосов
/ 24 октября

В моем случае у меня был дополнительный, очень старый ноутбук Ubuntu, который я уже использовал для воспроизведения контента DRM с помощью Chrome. Я решил настроить это как постоянное тестовое устройство для Android, к которому я мог бы получить доступ даже удаленно.

В другой ситуации можно создать образ докера с включенным Chrome. В этом сообщении блога подробно рассматриваются, но вот краткий план.

  1. Установка зависимостей из выпуска сообщества докеров: sudo apt-get install docker-ce -y; mkdir chrome-local; cd chrome-local;

  2. Внутри файла с именем: "Dockerfile", поместите:

FROM ubuntu:trusty

RUN apt-get update; apt-get clean

# Add a user for running applications.
RUN useradd apps
RUN mkdir -p /home/apps && chown apps:apps /home/apps

# Install x11vnc.
RUN apt-get install -y x11vnc

# Install xvfb.
RUN apt-get install -y xvfb

# Install fluxbox.
RUN apt-get install -y fluxbox

# Install wget.
RUN apt-get install -y wget

# Install wmctrl.
RUN apt-get install -y wmctrl

# Set the Chrome repo.
RUN wget -q -O - https://dl-ssl.google.com/linux/linux_signing_key.pub | apt-key add - \
    && echo "deb http://dl.google.com/linux/chrome/deb/ stable main" >> /etc/apt/sources.list.d/google.list

# Install Chrome.
RUN apt-get update && apt-get -y install google-chrome-stable

COPY bootstrap.sh /

CMD '/bootstrap.sh'
Внутри файла с именем bootstrap.sh поместите:


#!/bin/bash

# Based on: http://www.richud.com/wiki/Ubuntu_Fluxbox_GUI_with_x11vnc_and_Xvfb

readonly G_LOG_I='[INFO]'
readonly G_LOG_W='[WARN]'
readonly G_LOG_E='[ERROR]'

main() {
    launch_xvfb
    launch_window_manager
    run_vnc_server
}

launch_xvfb() {
    # Set defaults if the user did not specify envs.
    export DISPLAY=${XVFB_DISPLAY:-:1}
    local screen=${XVFB_SCREEN:-0}
    local resolution=${XVFB_RESOLUTION:-1280x1024x24}
    local timeout=${XVFB_TIMEOUT:-5}

    # Start and wait for either Xvfb to be fully up or we hit the timeout.
    Xvfb ${DISPLAY} -screen ${screen} ${resolution} &
    local loopCount=0
    until xdpyinfo -display ${DISPLAY} > /dev/null 2>&1
    do
        loopCount=$((loopCount+1))
        sleep 1
        if [ ${loopCount} -gt ${timeout} ]
        then
            echo "${G_LOG_E} xvfb failed to start."
            exit 1
        fi
    done
}

launch_window_manager() {
    local timeout=${XVFB_TIMEOUT:-5}

    # Start and wait for either fluxbox to be fully up or we hit the timeout.
    fluxbox &
    local loopCount=0
    until wmctrl -m > /dev/null 2>&1
    do
        loopCount=$((loopCount+1))
        sleep 1
        if [ ${loopCount} -gt ${timeout} ]
        then
            echo "${G_LOG_E} fluxbox failed to start."
            exit 1
        fi
    done
}

run_vnc_server() {
    local passwordArgument='-nopw'

    if [ -n "${VNC_SERVER_PASSWORD}" ]
    then
        local passwordFilePath="${HOME}/x11vnc.pass"
        if ! x11vnc -storepasswd "${VNC_SERVER_PASSWORD}" "${passwordFilePath}"
        then
            echo "${G_LOG_E} Failed to store x11vnc password."
            exit 1
        fi
        passwordArgument=-"-rfbauth ${passwordFilePath}"
        echo "${G_LOG_I} The VNC server will ask for a password."
    else
        echo "${G_LOG_W} The VNC server will NOT ask for a password."
    fi

    x11vnc -display ${DISPLAY} -forever ${passwordArgument} &
    wait $!
}

control_c() {
    echo ""
    exit
}

trap control_c SIGINT SIGTERM SIGHUP

main

exit

Создайте образ докера: chmod +x boostrap.sh; docker build -t local/chrome:0.0.1 . - Обратите внимание на трейлинг .! Это создает образ в Dockerfile выше и дает ему имя с именем local/chrome:0.0.1.

Запустите образ докера с помощью: docker run -p 5900:5900 -e VNC_SERVER_PASSWORD=password --user apps --privileged local/chrome:0.0.1

Используйте VNC-клиент для подключения к порту 5900, который содержит ваш образ докера

...